var Router = require('koa-router');
(function (HttpMethod) {
    HttpMethod[HttpMethod["HEAD"] = 0] = "HEAD";
    HttpMethod[HttpMethod["OPTIONS"] = 1] = "OPTIONS";
    HttpMethod[HttpMethod["GET"] = 2] = "GET";
    HttpMethod[HttpMethod["PUT"] = 3] = "PUT";
    HttpMethod[HttpMethod["PATCH"] = 4] = "PATCH";
    HttpMethod[HttpMethod["POST"] = 5] = "POST";
    HttpMethod[HttpMethod["DELETE"] = 6] = "DELETE";
})(exports.HttpMethod || (exports.HttpMethod = {}));
var HttpMethod = exports.HttpMethod;
function route(path, method) {
    var middleware = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        middleware[_i - 2] = arguments[_i];
    }
    return function (target, key, descriptor) {
        if (!path) {
            throw TypeError('@route should have at least "path" argument');
        }
        if (!target.prototype.router) {
            target.prototype.router = new Router();
        }
        if (target && !key && !descriptor) {
            if (method)
                throw TypeError('@route on class should not have "method"');
            target.prototype.router.prefix(path);
            if (middleware.length > 0) {
                (_a = target.prototype.router).use.apply(_a, middleware);
            }
            return;
        }
        if (!method) {
            throw TypeError('@route on method should have "method" as second argument');
        }
        switch (method) {
            case HttpMethod.HEAD:
                (_b = target.prototype.router).head.apply(_b, [path].concat(middleware, [descriptor.value]));
                break;
            case HttpMethod.OPTIONS:
                (_c = target.prototype.router).options.apply(_c, [path].concat(middleware, [descriptor.value]));
                break;
            case HttpMethod.GET:
                (_d = target.prototype.router).get.apply(_d, [path].concat(middleware, [descriptor.value]));
                break;
            case HttpMethod.PUT:
                (_e = target.prototype.router).put.apply(_e, [path].concat(middleware, [descriptor.value]));
                break;
            case HttpMethod.PATCH:
                (_f = target.prototype.router).patch.apply(_f, [path].concat(middleware, [descriptor.value]));
                break;
            case HttpMethod.POST:
                (_g = target.prototype.router).post.apply(_g, [path].concat(middleware, [descriptor.value]));
                break;
            case HttpMethod.DELETE:
                (_h = target.prototype.router).delete.apply(_h, [path].concat(middleware, [descriptor.value]));
                break;
            default:
                throw new TypeError('@route decorator "method" is not valid');
        }
        var _a, _b, _c, _d, _e, _f, _g, _h;
    };
}
exports.route = route;
//# sourceMappingURL=index.js.map